package logicNode.parser;

import java.util.TreeMap;

public class LogicNodeScope {
	public LogicNodeScope prev;
	public TreeMap<String,Token> scope;
	public Dictionary dict;
	

	public LogicNodeScope(Dictionary dict) {
		this.dict = dict;
		this.scope = new TreeMap<String,Token>();
	}
	
	public LogicNodeScope(LogicNodeScope scope) {
		prev = scope;
		this.dict = scope.dict;
		this.scope = new TreeMap<String,Token>();
	}

	public LogicNodeScope push() {
		return new LogicNodeScope(this);
	}
	
	public void pop() {
		for(String name: scope.keySet()) {
			Token t = scope.get(name);
			dict.put(name, t);
		}
	}
	
	public Token getLocalName(String name) {
		Token n = new Token(name);
		Token t=dict.get(name);
		scope.put(name, t);
		dict.put(name,n);
		return n;
	}
}
